﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameController : MonoBehaviour {

    [Header("Variables")]
    public int score = 0;
    public float startingLifes;
    protected float lifes;
    public PlayerController Player;
    string textscore = "00";
    bool GameOver;

    public ObstacleController[] Obstacles;
    int IndexObstacles = 0;
    int IndexKeysObstacles = 0;
    int IndexObstacleBulleShown = 42;

    int timer = 1000;
    int timerNext = 30;
    bool TimerBool = false;

    GameObject childObject;

    [Header("UI")]
    public Sprite[] BtnSprites;
    public GameObject[] Bulles;
    public Text ScoreText;
    public Image HealthBar;

    [Header("SOUNDS")]
    public AudioClip SonFlute1;
    public AudioClip SonFlute2;
    public AudioClip SonFlute3;
    public AudioClip SonFlute4;
    public AudioClip SonFlute5;


    void Start()
    {
        //SetScoreText();
        lifes = startingLifes;
        Player = GameObject.FindGameObjectWithTag("Player").GetComponent<PlayerController>();
    }

    /// <summary>
    /// 
    /// </summary>
    void Update()
    {
        int Input;

        //print("RunStart=" + Player.RunStart + "; Index:" + IndexObstacles + "/" + IndexObstacleBulleShown + ";GO=" + GameOver);

        if (Player.RunStart == true && IndexObstacles < Obstacles.Length && GameOver != true) {

            // Affichage Bulle Sur Nounours
            if (IndexObstacles != IndexObstacleBulleShown) {
                if (childObject != null) {
                    //print("DESTROY BULLE");
                    DestroyImmediate(childObject);
                }

                if (IndexObstacles != 0) {
                    if (Obstacles[IndexObstacles - 1].Next == true) {
                        childObject = Instantiate(Bulles[Obstacles[IndexObstacles].nbrKeys - 1], new Vector3(Player.transform.position.x, Player.transform.position.y + 2, Player.transform.position.z), Quaternion.identity) as GameObject;
                        childObject.transform.parent = Player.transform;

                        for (int i = 0; i < Obstacles[IndexObstacles].nbrKeys; i++) {
                            Transform Btn1 = childObject.gameObject.transform.GetChild(i).transform;
                            Btn1.gameObject.AddComponent<SpriteRenderer>().sprite = BtnSprites[Obstacles[IndexObstacles].Keys[i] - 1];
                            Btn1.gameObject.GetComponent<SpriteRenderer>().sortingLayerID = 1455475061;
                            Btn1.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                            //print(Obstacles[IndexObstacles].Keys[i]);
                        }
                        IndexObstacleBulleShown = IndexObstacles;
                        //print("CREATE BULLE : " + IndexObstacleBulleShown);
                    }

                } else {
                    childObject = Instantiate(Bulles[Obstacles[IndexObstacles].nbrKeys - 1], new Vector3(Player.transform.position.x, Player.transform.position.y + 2, Player.transform.position.z), Quaternion.identity) as GameObject;
                    childObject.transform.parent = Player.transform;

                    for (int i = 0; i < Obstacles[IndexObstacles].nbrKeys; i++) {
                        Transform Btn1 = childObject.gameObject.transform.GetChild(i).transform;
                        Btn1.gameObject.AddComponent<SpriteRenderer>().sprite = BtnSprites[Obstacles[IndexObstacles].Keys[i] - 1];
                        Btn1.gameObject.GetComponent<SpriteRenderer>().sortingLayerID = 1455475061;
                        Btn1.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        //print(Obstacles[IndexObstacles].Keys[i]);
                    }
                    IndexObstacleBulleShown = IndexObstacles;
                    //print("CREATE FIRST BULLE : " + IndexObstacleBulleShown);
                }
            }


            //print("Keys= " + IndexKeysObstacles + ":" + Obstacles[IndexObstacles].nbrKeys);
            if (IndexKeysObstacles < Obstacles[IndexObstacles].nbrKeys) {

                Input = GetInput();
                //print(Input);

                if (Input == Obstacles[IndexObstacles].Keys[IndexKeysObstacles]) {
                    //print("OK"); BTN CLICK

                    //print("Cache Btn " + IndexKeysObstacles);
                    Player.gameObject.transform.GetChild(0).GetChild(IndexKeysObstacles).GetComponent<SpriteRenderer>().color = new Color(255, 255, 255, 0);
                    switch (Input) {
                        case 1:
                            this.GetComponent<AudioSource>().PlayOneShot(SonFlute1, 1.0f);
                            break;
                        case 2:
                            this.GetComponent<AudioSource>().PlayOneShot(SonFlute2, 2.0f);
                            break;
                        case 3:
                            this.GetComponent<AudioSource>().PlayOneShot(SonFlute3, 1.0f);
                            break;
                        case 4:
                            this.GetComponent<AudioSource>().PlayOneShot(SonFlute4, 1.0f);
                            break;
                        default:
                            break;
                    }

                    IndexKeysObstacles++;
                    timer = 1000;

                } else if (Input != 0) {
                    //ERREUR !
                    //print("ERREUR!");

                    this.GetComponent<AudioSource>().PlayOneShot(SonFlute5, 1.0f);
                    for (int i = 0; i < IndexKeysObstacles; i++) {
                        Player.transform.GetChild(0).GetChild(i).GetComponent<SpriteRenderer>().color = new Color(255, 255, 255, 255);
                    }
                    IndexKeysObstacles = 0;
                    timer = 1000;

                } else {
                    if (timer > 0) {
                        timer--;
                    }
                }

            } else if (IndexKeysObstacles >= Obstacles[IndexObstacles].nbrKeys) {

                Obstacles[IndexObstacles].Done = true;
                if (IndexObstacles < Obstacles.Length) {
                    IndexObstacles++;
                }
                IndexKeysObstacles = 0;
            }
        }
    }

    public void ShowCommandForNextObstacle() {
        print("NEXT!");
        timerNext = 30;
        TimerBool = true;
    }

    void FixedUpdate()
    {
        if (TimerBool == true) {
            if (timerNext > 0) {
                timerNext--;
                print("TimerNext:" + timerNext);
            } else {
                Player.StopJumpAnim();
                TimerBool = false;
                Obstacles[IndexObstacles - 1].Next = true;
            }
        }
        

        if (score == 100)
        {
            lifes++;
            //TODO: Play sound here
            score = 0;
        }
        //SetScoreText();
    }

    public void LooseLife() {
        lifes -= 1;
        Player.SetRunStart(false);

        if (lifes <= 0) {
            SetGameOver();
        } else {
            Retry();
        }
    }

    void SetGameOver() {
        GameOver = true;
        print("GAME OVER!");
        SceneManager.LoadScene(2);
    }

    public void Retry() {
        if (childObject != null) {
            Destroy(childObject);
        }
        IndexObstacles = 0;
        IndexKeysObstacles = 0;
        IndexObstacleBulleShown = 42;
        timer = 1000;
        timerNext = 40;
        foreach (ObstacleController Obstacle in Obstacles) {
            //for (int i = 0; i < Obstacle.nbrKeys; i++) {
            //    Obstacle.gameObject.transform.GetChild(0).GetChild(i).GetComponent<SpriteRenderer>().color = new Color(255, 255, 255, 255);
            //}
            Obstacle.Done = false;
            Obstacle.Next = false;
        }
        Player.SetRetry();
        print("RETRY");
    }

    //Traduit les input du clavier et de la manette en int
    int GetInput()
    {
        int IntInput;
        if (Input.GetKeyDown(KeyCode.Alpha1) || Input.GetKeyDown(KeyCode.Joystick1Button0))
        {
            IntInput = 1;
        }
        else if (Input.GetKeyDown(KeyCode.Alpha2) || Input.GetKeyDown(KeyCode.Joystick1Button1))
        {
            IntInput = 2;
        }
        else if (Input.GetKeyDown(KeyCode.Alpha3) || Input.GetKeyDown(KeyCode.Joystick1Button2))
        {
            IntInput = 3;
        }
        else if (Input.GetKeyDown(KeyCode.Alpha4) || Input.GetKeyDown(KeyCode.Joystick1Button3))
        {
            IntInput = 4;
        }
        else
        {
            IntInput = 0;
        }
        return IntInput;
    }

    void SetScoreText()
    {
        if (score < 10)
        {
            textscore = "0" + score.ToString();
        }
        else
        {
            textscore = score.ToString();
        }
        ScoreText.text = textscore;
    }
}
