﻿using UnityEngine;
using System.Collections;

public class PlayerController : MonoBehaviour {

    [Header("Settings")]
    public float maxSpeed = 10f;
    public bool RunStart = false;

    public GameController GM;
    Rigidbody2D PlayerRigidbody;
    Animator anim;

    [Header("Jump settings")]
    public float jumpForce = 2f;
    //public Transform groundCheck;
    //public LayerMask whatIsGround;
    //bool grounded = false;
    //Vector2 groundSize = new Vector2(0.35f, 0.05f);

    public Vector2 savedVelocity;
    public Vector2 ActualVelocity;

    protected void Start()
    {
        anim = GetComponent<Animator>();
        PlayerRigidbody = GetComponent<Rigidbody2D>();
    }

    void Update()
    {
        ActualVelocity = GetComponent<Rigidbody2D>().velocity;

        //if (grounded && Input.GetKeyDown(KeyCode.Space))
        //{
        //    anim.SetBool("Ground", false);
        //    //anim.SetBool("Jump", true);
        //    GoatRigidbody.AddForce(new Vector2(0, jumpForce));
        //}
    }

    void FixedUpdate()
    {
        //grounded = Physics2D.OverlapBox(groundCheck.position, groundSize, 0.0f, whatIsGround);
        //anim.SetBool("Ground", grounded);

        //if (GoatRigidbody.velocity.y > 0)
        //{ // && anim.GetBool("Jump")
        //    anim.SetBool("Jump", true);
        //}
        //else
        //{
        //    anim.SetBool("Jump", false);
        //}
        //anim.SetFloat("Velocity", GoatRigidbody.velocity.y);

        //float move = Input.GetAxis("Horizontal");

        //anim.SetFloat("Speed", Mathf.Abs(move));
        if (Input.GetKeyDown(KeyCode.Space))
        {
            RunStart = true;
            anim.SetBool("Run", true);
        }

        if (RunStart == true)
        {
            PlayerRigidbody.velocity = new Vector2(1 * maxSpeed, PlayerRigidbody.velocity.y);
        }
    }

    public void Jump()
    {
        if (PlayerRigidbody != null) {
            PlayerRigidbody.AddForce(new Vector2(0, jumpForce));
            anim.SetBool("Jump", true);
        }
    }

    public void StopJumpAnim() {
        anim.SetBool("Jump", false);
    }

    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.gameObject.CompareTag("MusicNote"))
        {
            other.gameObject.SetActive(false);
            GameObject.FindGameObjectWithTag("GameController").GetComponent<GameController>().score++;
            //Destroy(gameObject);
        }
        else if (other.gameObject.CompareTag("Obstacle"))
        {
            if (other.gameObject.GetComponent<ObstacleController>().Done != true) {
                print("TAKE DAMAGE => -1Vies");
                GM.LooseLife();
            } else {
                print("Jump");
                GM.ShowCommandForNextObstacle();
                Jump();
                
            }
        }
    }

    public void SetRunStart(bool boolean) {
        this.RunStart = boolean;
    }

    public void SetRetry() {
        this.GetComponent<Transform>().position = new Vector3(-5, 1.3f, 0);
        PlayerRigidbody.velocity = new Vector2(0, 0);
        anim.SetBool("Run", false);
    }
}
